﻿using System;
using System.Collections.Generic;
using HttpCommander;
using System.Net;
using System.Web.Configuration;
using System.Web;
using System.IO;

public static class ExternalCMSIntegration
{
    public const string DrupalURL = "http://win2003-mws/drupal/account-check.php";
    public const string JoomlaURL = "http://win2003-mws/joomla/account-check.php";
    public const string WordPressURL = "http://win2003-mws/wordpress/account-check.php";

    public static bool ValidateUserPasswordDrupal(string name, string password)
    {
        return ValidateUserPasswordHashDrupal(name, Utils.CalculateMD5Hash(password));
    }
    public static bool ValidateUserPasswordHashDrupal(string name, string passwordHash)
    {
        string sURL = DrupalURL + "?"
            + "username=" + HttpUtility.UrlEncode(name)
            + "&passwordhash=" + HttpUtility.UrlEncode(passwordHash);

        WebRequest request = WebRequest.Create(sURL);
        Stream dataStream = request.GetResponse().GetResponseStream();
        StreamReader reader = new StreamReader(dataStream);
        string responseFromServer = reader.ReadToEnd();
        return responseFromServer == "yes";
    }
    public static bool ValidateUserPasswordJoomla(string name, string password)
    {
        string sURL = JoomlaURL + "?"
            + "username=" + HttpUtility.UrlEncode(name)
            + "&password=" + HttpUtility.UrlEncode(password);

        WebRequest request = WebRequest.Create(sURL);
        Stream dataStream = request.GetResponse().GetResponseStream();
        StreamReader reader = new StreamReader(dataStream);
        string responseFromServer = reader.ReadToEnd();
        return responseFromServer == "yes";
    }
    public static bool ValidateUserPasswordHashJoomla(string name, string passwordHash)
    {
        string sURL = JoomlaURL + "?"
            + "username=" + HttpUtility.UrlEncode(name)
            + "&passwordhash=" + HttpUtility.UrlEncode(passwordHash);

        WebRequest request = WebRequest.Create(sURL);
        Stream dataStream = request.GetResponse().GetResponseStream();
        StreamReader reader = new StreamReader(dataStream);
        string responseFromServer = reader.ReadToEnd();
        return responseFromServer == "yes";
    }
    public static bool ValidateUserPasswordWordPress(string name, string password)
    {
        string sURL = WordPressURL + "?"
            + "username=" + HttpUtility.UrlEncode(name)
            + "&password=" + HttpUtility.UrlEncode(password);

        WebRequest request = WebRequest.Create(sURL);
        Stream dataStream = request.GetResponse().GetResponseStream();
        StreamReader reader = new StreamReader(dataStream);
        string responseFromServer = reader.ReadToEnd();
        return responseFromServer == "yes";
    }
    public static bool ValidateUserPasswordHashWordPress(string name, string passwordHash)
    {
        string sURL = WordPressURL + "?"
            + "username=" + HttpUtility.UrlEncode(name)
            + "&passwordhash=" + HttpUtility.UrlEncode(passwordHash);

        WebRequest request = WebRequest.Create(sURL);
        Stream dataStream = request.GetResponse().GetResponseStream();
        StreamReader reader = new StreamReader(dataStream);
        string responseFromServer = reader.ReadToEnd();
        return responseFromServer == "yes";
    }


}