﻿<%@ Page Language="C#" %>
<%@ Import namespace="System.Net" %>
<%@ Import namespace="System.IO" %>
<%@ Import namespace="System.Drawing" %>
<%@ Import Namespace="HttpCommander" %>
<%@ Import Namespace="System.Web.Configuration" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
<script language="c#" runat="server">
        bool isMobileBrowser = false;
        string pageBodyStyle = "font-family: Tahoma; font-size: 13px;background-color:#ffffff;	color:#000000;";
        protected void Page_Load(object sender, EventArgs e)
        {   
            Response.Expires = -1;
            Response.CacheControl = "No-cache";
            Response.AppendHeader("X-HttpCommander-Status", "0");
            isMobileBrowser = isMobileBrowser || (Request.QueryString["Mobile"] != null);
            ValidateUserResult validateUserResult = ValidateUserResult.Failure;    
            string lang=null;
            
            if (!Page.IsPostBack)
            {
                Utils.RunShortDiagnostics();
                
                try
                {
                    lang = CheckLanguage();
                    if (lang != null && string.Compare(lang, Utils.CurrentLanguage, true) != 0 && Utils.AvailableLocalizations.Contains(lang))
                    {
                        Utils.LocalizationsManager = null;
                        Utils.CurrentLanguage = lang;
                        Utils.SetLanguageCookie(lang);
                    }
                }
                catch (Exception ex) { };
            }
            // Example using automatic logon with specified user credentials
            if (Request.QueryString["username"] != null)
            {
                string userName = Request.QueryString["username"].ToString();
                if (Request.QueryString["password"] != null)
                {
                    string password = Request.QueryString["password"].ToString();
                    IntPtr winUserToken = IntPtr.Zero;
                    if (Utils.UserSettings.WindowsUsersWithFormAuth && Utils.AccountsManager is WindowsAccountManager)
                    {
                        validateUserResult = (Utils.AccountsManager as WindowsAccountManager).ValidateUser(userName, password, out winUserToken);
                        GlobalCacheTokens.Instance.SetToken(userName, winUserToken);
                    }
                    else
                        validateUserResult = Utils.AccountsManager.ValidateUser(userName, password);
                }
                else if (Request.QueryString["passwordhash"] != null)
                {
                    string passwordHash = Request.QueryString["passwordhash"].ToString();
                    // uncomment the line below to allow login with passwordhash in URL. Check that Data\accounts.xml not available for users.
                    // validateUserResult = Utils.AccountsManager.ValidateUserHash(userName, passwordHash);
                }
                if (validateUserResult == ValidateUserResult.Success)
                {
                    FormsAuthentication.SetAuthCookie(userName, false);
                }
            }

            /*
            // automatic logon from CMS. See open source code at App_Code\ExternalCMSIntegration.cs
            if (Request.QueryString["username"] != null && Request.QueryString["passwordhash"] != null)
            {
                string userName = Request.QueryString["username"].ToString();
                string passwordHash = Request.QueryString["passwordhash"].ToString();
                //if (ExternalCMSIntegration.ValidateUserPasswordHashDrupal(userName, passwordHash))
                //if (ExternalCMSIntegration.ValidateUserPasswordHashJoomla(userName, passwordHash))
                //if (ExternalCMSIntegration.ValidateUserPasswordHashWordPress(userName, passwordHash))
                {
                    FormsAuthentication.SetAuthCookie(userName, false);
                    isAuthenticated = true;
                }
            }
            */            
            
            if (!User.Identity.IsAuthenticated && validateUserResult != ValidateUserResult.Success)
            {
                /*Add meta tag for mobile browsers each time when page rendered expect postback
                * When login form submited user may want to load standard interface instead of mobile
               */
                if (!Page.IsPostBack || Request.QueryString["RecoverPassword"] != null || Request.QueryString["Register"] != null || Request.QueryString["ChangeEmail"] != null)
                    AddMeta("viewport", "width=device-width; initial-scale=1.0; maximum-scale=1.0; minimum-scale=1.0; user-scalable=0;", this.Page);
                
                if (Request.QueryString["RecoverPassword"] != null && Utils.UserSettings.EnablePasswordRecovery && !Utils.UserSettings.WindowsUsersWithFormAuth)
                    RenderRecoverPasswordForm();
                else if (Request.QueryString["Register"] != null && Utils.UserSettings.EnableAnonymRegister && !Utils.UserSettings.WindowsUsersWithFormAuth)
                    RenderRegisterForm();
                else if (Request.QueryString["ChangeEmail"] != null && Utils.UserSettings.EnableChangeEmail && !Utils.UserSettings.WindowsUsersWithFormAuth)
                    RenderChangeEmailForm();
                else
                {
                    RenderLoginForm(validateUserResult);                    
                }
            }
            else
            {
                if (Utils.UserSettings.AuthMode == AuthenticationMode.Windows)
                {
                    // OnLogin event with Windows authentication
                    Log.OnLogin();
                }
                RenderMainBody();
            }            
        }

        protected string CheckLanguage()
        {
            //Read if default language passed at URL like HTCOMNET/Default.aspx?Language=Spanish
            //Language parameter is case sensitive!
            if (Request.QueryString["Language"] != null && Request.QueryString["Language"].Length>0)
            {
                string firstLetter = Request.QueryString["Language"].Substring(0, 1);
                string correctedLang = firstLetter.ToUpper() + Request.QueryString["Language"].Remove(0, 1);
                return correctedLang;
            }
                
            if (Request.Cookies != null && Request.Cookies["htclang"] != null)
            {
                string langCookie = Utils.DecodeFrom64(Request.Cookies["htclang"].Value);
                return langCookie;
            }
            /*if (Request.UserLanguages != null && Request.UserLanguages.Length>0)
            {
                string firstlang = Request.UserLanguages[0];
                if (firstlang.IndexOf("-") >= 0)
                    firstlang = firstlang.Substring(0, firstlang.IndexOf("-"));
                string langName = GoogleLanguageCodes.LanguageIDToName(firstlang);
                if (langName != null)
                {
                    return langName;
                }
            }*/
            return null;
        }
                    
        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
            isMobileBrowser = detectMobileBrowser();            
        }

        protected Boolean detectMobileBrowser()
        {
            Regex b = new Regex(@"android|avantgo|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\\/|plucker|pocket|psp|symbian|treo|up\\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino", RegexOptions.IgnoreCase | RegexOptions.Multiline);
            Regex v = new Regex(@"1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\\-(n|u)|c55\\/|capi|ccwa|cdm\\-|cell|chtm|cldc|cmd\\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\\-s|devi|dica|dmob|do(c|p)o|ds(12|\\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\\-|_)|g1 u|g560|gene|gf\\-5|g\\-mo|go(\\.w|od)|gr(ad|un)|haie|hcit|hd\\-(m|p|t)|hei\\-|hi(pt|ta)|hp( i|ip)|hs\\-c|ht(c(\\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\\-(20|go|ma)|i230|iac( |\\-|\\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\\/)|klon|kpt |kwc\\-|kyo(c|k)|le(no|xi)|lg( g|\\/(k|l|u)|50|54|e\\-|e\\/|\\-[a-w])|libw|lynx|m1\\-w|m3ga|m50\\/|ma(te|ui|xo)|mc(01|21|ca)|m\\-cr|me(di|rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\\-2|po(ck|rt|se)|prox|psio|pt\\-g|qa\\-a|qc(07|12|21|32|60|\\-[2-7]|i\\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\\-|oo|p\\-)|sdk\\/|se(c(\\-|0|1)|47|mc|nd|ri)|sgh\\-|shar|sie(\\-|m)|sk\\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\\-|v\\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\\-|tdg\\-|tel(i|m)|tim\\-|t\\-mo|to(pl|sh)|ts(70|m\\-|m3|m5)|tx\\-9|up(\\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|xda(\\-|2|g)|yas\\-|your|zeto|zte\\-", RegexOptions.IgnoreCase | RegexOptions.Multiline);
            return detectMobileBrowser(b, v);
        }
            
        protected Boolean detectMobileBrowser(Regex agents, Regex versions)
        {
            String useragent = Request.ServerVariables["HTTP_USER_AGENT"];
		    if (string.IsNullOrEmpty(Request.ServerVariables["HTTP_USER_AGENT"]))
                return false;
            return agents.IsMatch(useragent) || (versions != null && versions.IsMatch(useragent.Substring(0, 4)));           
        }

        protected Boolean isSenchaSupported()
        {
            String useragent = Request.ServerVariables["HTTP_USER_AGENT"];
            if (string.IsNullOrEmpty(Request.ServerVariables["HTTP_USER_AGENT"]))
                return false;
            Match result = Regex.Match(useragent, "AppleWebKit/([\\d]+\\.)", RegexOptions.IgnoreCase);
            double webKitVersion = 0.0;
            if (result.Success && result.Groups.Count > 1)
            {
                try
                {
                    webKitVersion = double.Parse(result.Groups[1].Value);
                }
                catch (Exception e) { }
            }
            return webKitVersion > 528.0;
        }
     

        protected void btnLogin_Click(object sender, EventArgs e)
        {
            ValidateUserResult validateUserResult = ValidateUserResult.Failure;
            IntPtr winUserToken = IntPtr.Zero;
            if (Utils.UserSettings.WindowsUsersWithFormAuth && Utils.AccountsManager is WindowsAccountManager)
            {
                validateUserResult = (Utils.AccountsManager as WindowsAccountManager).ValidateUser(txtUserName.Text, txtPassword.Text, out winUserToken);
                GlobalCacheTokens.Instance.SetToken(txtUserName.Text, winUserToken);
            }
            else
                validateUserResult = Utils.AccountsManager.ValidateUser(txtUserName.Text, txtPassword.Text);
            // automatic logon from CMS. See open source code at App_Code\ExternalCMSIntegration.cs
            //ValidateUserResult validateUserResult = ExternalCMSIntegration.ValidateUserPasswordDrupal(txtUserName.Text, txtPassword.Text) ? ValidateUserResult.Success : ValidateUserResult.Failure;
            //ValidateUserResult validateUserResult = ExternalCMSIntegration.ValidateUserPasswordJoomla(txtUserName.Text, txtPassword.Text) ? ValidateUserResult.Success : ValidateUserResult.Failure;
            //ValidateUserResult validateUserResult = ExternalCMSIntegration.ValidateUserPasswordWordPress(txtUserName.Text, txtPassword.Text) ? ValidateUserResult.Success : ValidateUserResult.Failure;
            if (validateUserResult == ValidateUserResult.Success)
            {
                lblStatus.Visible = false;
                Utils.LocalizationsManager = null;
                Utils.CurrentLanguage = ddlLanguages.Text;
                Utils.SetLanguageCookie(ddlLanguages.Text);
                FormsAuthentication.SetAuthCookie(txtUserName.Text, cbRemember.Checked);
                RenderMainBody();
                // OnLogin event with Forms authentication
                Log.OnLogin(txtUserName.Text);
                if (Request.QueryString["ReturnUrl"] != null)
                {
                    string ReturnUrl = Request.QueryString["ReturnUrl"];
                    Response.Redirect(ReturnUrl);
                }
            }
            else
            {
                /*If login was not successfull, add meta tag for mobile browser,
                 * otherwise tag will be added in RenderMainBody depending on interface selected by user
                */
                if(isMobileBrowser)
                    AddMeta("viewport", "width=device-width; initial-scale=1.0; maximum-scale=1.0; minimum-scale=1.0; user-scalable=0;", this.Page);
                LoginErrorMessage(validateUserResult);
                lblStatus.Visible = true;
            }
        }

        protected void btnEmailPass_Click(object sender, EventArgs e)
        {
            if (Utils.UserSettings.IsDemoMode)
            {
                if (Utils.IsDemoUser(txtRecoverPassUserName.Text))
                {
                    lblRecoverPassStatus.Text = Utils.LocalizationsManager.GetString("ServerDemoMode");
                    lblRecoverPassStatus.ForeColor = Color.Red;
                    lblRecoverPassStatus.Visible = true;
                    return;
                }
            }
            if (!Utils.UserSettings.EnablePasswordRecovery || Utils.UserSettings.WindowsUsersWithFormAuth)
                return;
            if (!Utils.AccountsManager.ExistsUser(txtRecoverPassUserName.Text))
            {
                lblRecoverPassStatus.Text = Utils.LocalizationsManager.GetString("RecoverPasswordErrorInvalidUserName");
                lblRecoverPassStatus.ForeColor = Color.Red;
                lblRecoverPassStatus.Visible = true;
                return;
            }
            if (!Utils.AccountsManager.UserHasEmail(txtRecoverPassUserName.Text))
            {
                lblRecoverPassStatus.Text = Utils.LocalizationsManager.GetString("RecoverPasswordErrorNoEmail");
                lblRecoverPassStatus.ForeColor = Color.Red;
                lblRecoverPassStatus.Visible = true;
                return;
            }
            if (!Utils.AccountsManager.EmailUserPassword(txtRecoverPassUserName.Text))
            {
                lblRecoverPassStatus.Text = Utils.LocalizationsManager.GetString("RecoverPasswordErrorSendEmail");
                lblRecoverPassStatus.ForeColor = Color.Red;
                lblRecoverPassStatus.Visible = true;
                return;
            }
            lblRecoverPassStatus.Text = Utils.LocalizationsManager.GetString("RecoverPasswordSuccess");
            lblRecoverPassStatus.ForeColor = Color.Green;
            lblRecoverPassStatus.Visible = true;
        }

        protected void btnChangeEmailSubmit_Click(object sender, EventArgs e)
        {
            if (!Utils.UserSettings.EnableChangeEmail || Utils.UserSettings.WindowsUsersWithFormAuth)
                return;
            ValidateUserResult validateUserResult = Utils.AccountsManager.ValidateUser(txtChangeEmailUserName.Text, txtChangeEmailUserPassword.Text);
            if (validateUserResult == ValidateUserResult.Blocked)
            {
                lblChangeEmailStatus.Text = string.Format(Utils.LocalizationsManager.GetString("LoginBlocked"), LoginAttempts.BlockTimeoutMinutes);
                lblChangeEmailStatus.ForeColor = Color.Red;
                lblChangeEmailStatus.Visible = true;
                return;
            }
            if(validateUserResult == ValidateUserResult.Failure)
            {
                lblChangeEmailStatus.Text = Utils.LocalizationsManager.GetString("LoginFailure");
                lblChangeEmailStatus.ForeColor = Color.Red;
                lblChangeEmailStatus.Visible = true;
                return;
            }
            User user = Utils.AccountsManager.GetUser(txtChangeEmailUserName.Text);
            if (user == null)
            {
                lblChangeEmailStatus.Text = Utils.LocalizationsManager.GetString("LoginFailure");
                lblChangeEmailStatus.ForeColor = Color.Red;
                lblChangeEmailStatus.Visible = true;
                return;
            }
            user.Email = txtChangeEmailEmail.Text;
            ((XmlAccountManager)Utils.AccountsManager).SaveToXml();
            lblChangeEmailStatus.Text = Utils.LocalizationsManager.GetString("ChangeEmailStatusSuccess");
            lblChangeEmailStatus.ForeColor = Color.Green;
            lblChangeEmailStatus.Visible = true;
        }

        protected void btnRegisterSubmit_Click(object sender, EventArgs e)
        {
            if (!Utils.UserSettings.EnableAnonymRegister || Utils.UserSettings.WindowsUsersWithFormAuth)
                return;
            if (txtRegisterPassword.Text != txtRegisterPassword2.Text)
            {
                lblRegisterStatus.Text = Utils.LocalizationsManager.GetString("RegisterErrorPasswordNotMatch");
                lblRegisterStatus.ForeColor = Color.Red;
                tblRegisterStatus.Visible = true;
                txtRegisterCaptcha.Text = "";
                return;
            }
            if (this.Session["CaptchaImageTextPrev"].ToString() != txtRegisterCaptcha.Text)
            {
                lblRegisterStatus.Text = Utils.LocalizationsManager.GetString("RegisterErrorCaptchaInvalid");
                lblRegisterStatus.ForeColor = Color.Red;
                tblRegisterStatus.Visible = true;
                txtRegisterCaptcha.Text = "";
                return;
            }
            if (Utils.AccountsManager.ExistsUser(txtRegisterUserName.Text))
            {
                lblRegisterStatus.Text = Utils.LocalizationsManager.GetString("RegisterErrorUserExists");
                lblRegisterStatus.ForeColor = Color.Red;
                tblRegisterStatus.Visible = true;
                txtRegisterCaptcha.Text = "";
                return;
            }
            HttpCommander.User user = new HttpCommander.User(
                txtRegisterUserName.Text,
                txtRegisterPassword.Text,
                txtRegisterEmail.Text);
            user.CustomField = txtRegisterExtraInfo.Text;
            Utils.AccountsManager.AddUserWithDefaultGroups(user);
            HttpCommander.EmailNotif.Main.SendEmailUserRegistered(user.Name, user.Email);
            lblRegisterStatus.ForeColor = Color.Green;
            lblRegisterStatus.Text = Utils.LocalizationsManager.GetString("RegisterSuccess");
            tblRegisterStatus.Visible = true;
            tblRegisterFields.Visible = false;
            tblRegisterStatus.Height = "150px";
        }

        public static void AddCss(string path, Page page)
        {
            Literal cssFile = new Literal();
            cssFile.Text = @"<link href=""" + path + @""" type=""text/css"" rel=""stylesheet"" />";
            page.Header.Controls.Add(cssFile);
        }

        public static void AddCss(string path, Page page, string title)
        {
            if (string.IsNullOrEmpty(title))
                AddCss(path, page);
            else
            {
                Literal cssFile = new Literal();
                cssFile.Text = @"<link title=""" + title + @""" href=""" + path + @""" type=""text/css"" rel=""stylesheet"" />";
                page.Header.Controls.Add(cssFile);
            }
        }

        public static void AddMeta(string name, string value, Page page)
        {
            Literal metaTag = new Literal();
            metaTag.Text = @"<meta name="""+name+@""" content="""+value+@""" />";        
            page.Header.Controls.Add(metaTag);
        }


        public static void AddScript(string src, Boolean isCode, Page page)
        {
            Literal scriptTag = new Literal();
            scriptTag.Text = @"<script type=""text/javascript""";
            if(!isCode)
                scriptTag.Text += "src=\"" + src + @""">";
            else
                scriptTag.Text += ">"+src;
            scriptTag.Text += "<"+"/script>"; 
            page.Header.Controls.Add(scriptTag);
        }

        private void RenderLinksBlock()
        {
            linksBlock.Visible = true;
            lnkLogin.Text = "|&nbsp;" + Utils.LocalizationsManager.GetString("LoginLinkText") + "&nbsp;|";
            lnkRecoverPassword.Text = "|&nbsp;" + Utils.LocalizationsManager.GetString("RecoverPasswordLinkText") + "&nbsp;|";
            lnkRecoverPassword.Visible = Utils.UserSettings.EnablePasswordRecovery;
            lnkRegister.Text = "|&nbsp;" + Utils.LocalizationsManager.GetString("RegisterLinkText") + "&nbsp;|";
            lnkRegister.Visible = Utils.UserSettings.EnableAnonymRegister;
            lnkChangeEmail.Text = "|&nbsp;" + Utils.LocalizationsManager.GetString("ChangeEmail") + "&nbsp;|";
            lnkMobileVersion.Visible = !isMobileBrowser && !lnkLogin.Visible;
 			lnkMobileVersion.Text = Utils.LocalizationsManager.GetString("LoginMobileVersionLinkText");
        }

        private void DisableAllForms()
        {
            formLogin.Visible = false;
            formRecoverPass.Visible = false;
            formChangeEmail.Visible = false;
            formRegister.Visible = false;
            mainBody.Visible = false;
            touchBody.Visible = false;
            jqmBody.Visible = false;
        }

        private void RenderRecoverPasswordForm()
        {
            RenderLinksBlock();
            lnkRecoverPassword.Visible = false;
            DisableAllForms();
            formRecoverPass.Visible = true;
            lblRecoverPassTitle.Text = Utils.LocalizationsManager.GetString("RecoverPasswordTitle");
            lblRecoverPassUserNameCaption.Text = Utils.LocalizationsManager.GetString("RecoverPasswordUserName") + ":";
            btnEmailPass.Text = Utils.LocalizationsManager.GetString("RecoverPasswordEmailPassword");
        }

        private void RenderChangeEmailForm()
        {
            RenderLinksBlock();
            lnkChangeEmail.Visible = false;
            DisableAllForms();
            formChangeEmail.Visible = true;
            lblChangeEmailTitle.Text = Utils.LocalizationsManager.GetString("ChangeEmailTitle");
            lblChangeEmailUserNameCaption.Text = Utils.LocalizationsManager.GetString("ChangeEmailUserName") + ":";
            lblChangeEmailUserPasswordCaption.Text = Utils.LocalizationsManager.GetString("ChangeEmailUserPassword") + ":";
            lblChangeEmailEmailCaption.Text = Utils.LocalizationsManager.GetString("ChangeEmailEmail") + ":";
            btnChangeEmailSubmit.Text = Utils.LocalizationsManager.GetString("ChangeEmailSubmit");
        }

        private void RenderRegisterForm()
        {
            RenderLinksBlock();
            lnkRegister.Visible = false;
            DisableAllForms();
            formRegister.Visible = true;
            lblRegisterTitle.Text = Utils.LocalizationsManager.GetString("RegisterTitle");
            lblRegisterUserNameCaption.Text = Utils.LocalizationsManager.GetString("RegisterUserName") + ":";
            lblRegisterPasswordCaption.Text = Utils.LocalizationsManager.GetString("RegisterPassword") + ":";
            lblRegisterPasswordCaption2.Text = Utils.LocalizationsManager.GetString("RegisterPasswordRepeat") + ":";
            lblRegisterEmailCaption.Text = Utils.LocalizationsManager.GetString("RegisterEmail") + ":";
            lblRegisterExtraInfoCaption.Text = Utils.LocalizationsManager.GetString("RegisterExtraInfo") + ":";
            lblRegisterCaptchaCaption.Text = Utils.LocalizationsManager.GetString("RegisterCaptcha") + ":";
            btnRegisterSubmit.Text = Utils.LocalizationsManager.GetString("RegisterSubmit");
            tblRegisterFields.Visible = true;
            tblRegisterStatus.Visible = false;
            tblRegisterStatus.Height = "auto";
            this.Session["CaptchaImageTextPrev"] = this.Session["CaptchaImageText"];
            this.Session["CaptchaImageText"] = GenerateRandomCode();
        }

        private void RenderLoginForm(ValidateUserResult validateUserResult)
        {
            lnkLogin.Visible = false;                        
            RenderLinksBlock();
            
            DisableAllForms();
            formLogin.Visible = true;

            if (!Page.IsPostBack)
            {
                ddlLanguages.DataSource = Utils.AvailableLocalizations;
                ddlLanguages.SelectedValue = Utils.CurrentLanguage;
                ddlLanguages.DataBind();                
            }
            if (isMobileBrowser)
            {
                uiVersionLabel.Text = Utils.LocalizationsManager.GetString("LoginUISelect");
                ui_standardLabel.Text = Utils.LocalizationsManager.GetString("LoginUIStandard");
                ui_touchLabel.Text = Utils.LocalizationsManager.GetString("LoginUITouch");               
            }
            lblLoginTitle.Text = Utils.LocalizationsManager.GetString("LoginTitle");
            lblUserNameCaption.Text = Utils.LocalizationsManager.GetString("LoginUserName") + ":";
            lblPasswordCaption.Text = Utils.LocalizationsManager.GetString("LoginPassword") + ":";
            cbRemember.Text = Utils.LocalizationsManager.GetString("LoginRemember");
            lblLanguageCaption.Text = Utils.LocalizationsManager.GetString("LoginLanguage");
            LoginErrorMessage(validateUserResult);
            btnLogin.Text = Utils.LocalizationsManager.GetString("LoginLogin");
        }

        private void RenderMainBody()
        {
            if (this.Session != null)
                this.Session["DefaultQueryString"] = Request.Url.Query; 
            
            linksBlock.Visible = false;
            DisableAllForms();
            Boolean loadSencha = (isMobileBrowser && ui_touch.Checked && isSenchaSupported()) || (Request.QueryString["Mobile"] != null && Request.QueryString["Mobile"].IndexOf("sencha", 0, StringComparison.OrdinalIgnoreCase) >= 0);
            Boolean loadJqm = (isMobileBrowser && ui_touch.Checked && !isSenchaSupported()) || (Request.QueryString["Mobile"] != null && Request.QueryString["Mobile"].IndexOf("jqm", 0, StringComparison.OrdinalIgnoreCase) >= 0);
            Boolean loadStandard = !isMobileBrowser || (isMobileBrowser && !ui_touch.Checked) || (Request.QueryString["Mobile"] != null && Request.QueryString["Mobile"].IndexOf("standard",0, StringComparison.OrdinalIgnoreCase) >=0) || Request.QueryString["Standard"]!=null;
            //Show mobile view for Forms authenticstion if MobileBrowser and Touch screen is checked
            //or for Windows authentication if Mobile= at the URL exists
            if (!loadStandard)
            {
                pageBodyStyle = "";
                if (loadJqm)
                {
                    jqmBody.Visible = true;
                    AddCss("Images/resources_1.5/mobile/jquery/jquery.mobile-1.0a4.1.1.css", this.Page, "default");

                    AddScript("Scripts/mobile/jquery/jquery-1.5.2.min.js", false, this.Page);
                    AddScript(@"
                                try{
                                    $(document).bind(""mobileinit"", function() {
                                        $.mobile.ajaxEnabled = false;
                                        $.mobile.ajaxFormsEnabled = false;
                                        $.mobile.loadingMessage = """+ HttpCommander.Utils.LocalizationsManager.GetString("ProgressLoading")+@""";
                                        }); } catch(e){}", true, this.Page);
                    AddScript("Scripts/mobile/jquery/jquery.mobile-1.0a4.1.1.min.js", false, this.Page);
                    AddScript("Scripts/mobile/jquery/jquery.json-2.2.min.js", false, this.Page);
       
                }
                else if (loadSencha)
                {
                    touchBody.Visible = true;
                    AddCss("Images/resources_1.5/mobile/sencha/css/sencha-touch.css", this.Page, "default");                    
                }
                AddMeta("viewport", "width=device-width; initial-scale=1.0; maximum-scale=1.0; minimum-scale=1.0; user-scalable=0;", this.Page);                    
            }
            else
            {
                mainBody.Visible = true;
                //AddCss("Images/resources_1.5/css/ext-all-notheme.css", this.Page);
                //AddCss("Images/resources_1.5/css/xtheme-gray.css", this.Page, "gray");
                //AddCss("Images/resources_1.5/css/xtheme-access.css", this.Page, "access");
                AddCss("Images/resources_1.5/css/ext-all.css", this.Page, "default");
                AddCss("Images/resources_1.5/css/ext-filters.css", this.Page);                
            }
            AddCss("Styles.css", this.Page);
        }

        private string GenerateRandomCode()
        {
            Random random = new Random();
            string s = string.Empty;
            for (int i = 0; i < 6; i++)
                s = String.Concat(s, random.Next(10).ToString());
            return s;
        }

        private void LoginErrorMessage(ValidateUserResult validateUserResult)
        {
            if (validateUserResult == ValidateUserResult.Blocked)
                lblStatus.Text = string.Format(Utils.LocalizationsManager.GetString("LoginBlocked"), LoginAttempts.BlockTimeoutMinutes);
            else
                lblStatus.Text = Utils.LocalizationsManager.GetString("LoginFailure");
        }

        protected void ddlLanguages_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (string.Compare(ddlLanguages.Text, Utils.CurrentLanguage, true) != 0)
            {
                Utils.LocalizationsManager = null;
                Utils.CurrentLanguage = ddlLanguages.Text;
                Utils.SetLanguageCookie(ddlLanguages.Text);
                RenderLoginForm(ValidateUserResult.Failure);
            }            
        }
</script>
    <title><%= Utils.LocalizationsManager.GetString("CommonMainTitle")%></title><!-- If you got error "Could not load file or assembly 'System.Xml.Linq" at this line then 
you should install .NET Framework 3.5 !-->
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
    <meta content="NOINDEX,NOFOLLOW" name="ROBOTS" />
</head>
<body id="pageBody" style="<%= pageBodyStyle %>">
    <form id="formLogin" runat="server">
    <div align="center">
    <noscript><font color="#CC0000"><%= HttpCommander.Utils.LocalizationsManager.GetString("CommonNoScript")%></font><br/></noscript>
        <table style="width: 300px; background-color: #DFE8F6; border: 1px #99BBE8 solid"
            cellpadding="3">
            <tr>
                <td colspan="3" height="24" align="center">
					<!-- Uncomment img tag below if you to show logo -->
				<!--	<img src="Scripts/logolarge.png" align="absmiddle" width="194" height="33" alt="" /><br/> -->
                    <asp:Label ID="lblLoginTitle" runat="server" Font-Bold="True" ForeColor="#15428B" Text="HTTP Commander Login"></asp:Label>
                </td>
            </tr>
            <tr>
                <td align="right">
                    <asp:Label ID="lblUserNameCaption" runat="server" Text="User name:"></asp:Label>
                </td>
                <td colspan="2" align="left">
                    <asp:TextBox ID="txtUserName" runat="server" Width="140px"></asp:TextBox>
                    <asp:RequiredFieldValidator ID="rfvUserName" runat="server" ControlToValidate="txtUserName"
                        ErrorMessage="*"></asp:RequiredFieldValidator>
                </td>
            </tr>
            <tr>
                <td align="right">
                    <asp:Label ID="lblPasswordCaption" runat="server" Text="Password:"></asp:Label>
                </td>
                <td colspan="2" align="left">
                    <asp:TextBox ID="txtPassword" runat="server" Width="140px" TextMode="Password"></asp:TextBox>
                    <asp:RequiredFieldValidator ID="rfvPassword" runat="server" ControlToValidate="txtPassword"
                        ErrorMessage="*"></asp:RequiredFieldValidator>
                </td>
            </tr>
            <tr>
                <td>&nbsp;
                    
                </td>
                <td colspan="2" align="left">
                    <asp:CheckBox ID="cbRemember" runat="server" Text="Remember me next time" />
                </td>
            </tr>
            <% //Do not render table row with interface selection for unsupported browsers
               if (isMobileBrowser)
               { %>
            <tr>
                <td align="right">
                    <asp:Label ID="uiVersionLabel" runat="server" Text="Interface:"></asp:Label>
                   
                </td>
                <td align="left" colspan="2">
                    <asp:RadioButton ID="ui_standard" runat="server" GroupName="uiVersion" value="standard"/>
                      <asp:Label ID="ui_standardLabel" runat="server" Text="Standard"></asp:Label>
                    <asp:RadioButton ID="ui_touch" runat="server" GroupName="uiVersion" Checked="true" value="touch"/>
                    <asp:Label ID="ui_touchLabel" runat="server" Text="Touch"></asp:Label>               
                </td>
            </tr>
            <% } %>
            <tr>
                <td align="right">
                    <asp:Label ID="lblLanguageCaption" runat="server" Text="Language:"></asp:Label>
                </td>
                <td align="left">
                    <table width="100%" border="0">
                        <tr>
                        <td width="20">
                            <img src="Images/language.png" align="absmiddle" width="16" height="16" alt="" />
                        </td>
                        <td>
                    <asp:DropDownList ID="ddlLanguages" runat="server" Width="100px" 
                                onselectedindexchanged="ddlLanguages_SelectedIndexChanged" 
                                AutoPostBack="True">
                    </asp:DropDownList>
                           </td>
                        </tr>
                    </table>
                </td>
                <td align="right">
                    <asp:Button style="font-family: Tahoma; font-size: 13px;" ID="btnLogin" runat="server" Text="Login"
                        OnClick="btnLogin_Click"/>
                </td>                
            </tr>
            
            <tr>
                <td align="center" colspan="3">
                    <asp:Label ID="lblStatus" runat="server" ForeColor="Red" Text="* Your login attempt was not successful."
                        Visible="False"></asp:Label>
                </td>
            </tr>
        </table>
    </div>
    </form>
    
    <form id="formRecoverPass" runat="server">
        <div align="center">
        <table style="width: 300px; background-color: #DFE8F6; border: 1px #99BBE8 solid"
            cellpadding="3">
            <tr>
                <td colspan="3" height="24" align="center">
                    <asp:Label ID="lblRecoverPassTitle" runat="server" Font-Bold="True" ForeColor="#15428B" Text="Recover password"></asp:Label>
                </td>
            </tr>
            <tr>
                <td align="right">
                    <asp:Label ID="lblRecoverPassUserNameCaption" runat="server" Text="User name:"></asp:Label>
                </td>
                <td colspan="2" align="left">
                    <asp:TextBox ID="txtRecoverPassUserName" runat="server" Width="140px"></asp:TextBox>
                    <asp:RequiredFieldValidator ID="RequiredFieldValidator1" runat="server" ControlToValidate="txtRecoverPassUserName"
                        ErrorMessage="*"></asp:RequiredFieldValidator>
                </td>
            </tr>
            <tr>
                <td align="center" colspan="3">
                <asp:Button style="font-family: Tahoma; font-size: 13px;" ID="btnEmailPass" runat="server" Text="Email password"
                        OnClick="btnEmailPass_Click" />
                </td>
            </tr>
            <tr>
                <td align="center" colspan="3">
                    <asp:Label ID="lblRecoverPassStatus" runat="server" ForeColor="Red" Text="Invalid user name."
                        Visible="False"></asp:Label>
                </td>
            </tr>
        </table>
        </div>
    </form>
    
    <form id="formChangeEmail" runat="server">
        <div align="center">
        <table style="width: 300px; background-color: #DFE8F6; border: 1px #99BBE8 solid"
            cellpadding="3">
            <tr>
                <td colspan="3" height="24" align="center">
                    <asp:Label ID="lblChangeEmailTitle" runat="server" Font-Bold="True" ForeColor="#15428B" Text="Change email"></asp:Label>
                </td>
            </tr>
            <tr>
                <td align="right">
                    <asp:Label ID="lblChangeEmailUserNameCaption" runat="server" Text="User name:"></asp:Label>
                </td>
                <td colspan="2" align="left">
                    <asp:TextBox ID="txtChangeEmailUserName" runat="server" Width="140px"></asp:TextBox>
                    <asp:RequiredFieldValidator ID="RequiredFieldValidator6" runat="server" ControlToValidate="txtChangeEmailUserName"
                        ErrorMessage="*"></asp:RequiredFieldValidator>
                </td>
            </tr>
            <tr>
                <td align="right">
                    <asp:Label ID="lblChangeEmailUserPasswordCaption" runat="server" Text="User password:"></asp:Label>
                </td>
                <td colspan="2" align="left">
                    <asp:TextBox ID="txtChangeEmailUserPassword" runat="server" Width="140px" TextMode="Password"></asp:TextBox>
                    <asp:RequiredFieldValidator ID="RequiredFieldValidator7" runat="server" ControlToValidate="txtChangeEmailUserPassword"
                        ErrorMessage="*"></asp:RequiredFieldValidator>
                </td>
            </tr>
            <tr>
                <td align="right">
                    <asp:Label ID="lblChangeEmailEmailCaption" runat="server" Text="Email:"></asp:Label>
                </td>
                <td colspan="2" align="left">
                    <asp:TextBox ID="txtChangeEmailEmail" runat="server" Width="140px"></asp:TextBox>
                    <asp:RequiredFieldValidator ID="RequiredFieldValidator8" runat="server" ControlToValidate="txtChangeEmailEmail"
                        ErrorMessage="*"></asp:RequiredFieldValidator>
                </td>
            </tr>
            <tr>
                <td align="center" colspan="3">
                <asp:Button style="font-family: Tahoma; font-size: 13px;" ID="btnChangeEmailSubmit" runat="server" Text="Change email"
                        OnClick="btnChangeEmailSubmit_Click" />
                </td>
            </tr>
            <tr>
                <td align="center" colspan="3">
                    <asp:Label ID="lblChangeEmailStatus" runat="server" ForeColor="Red" Text="Invalid user name."
                        Visible="False"></asp:Label>
                </td>
            </tr>
        </table>
        </div>
    </form>
    
    <form id="formRegister" runat="server">
        <div align="center">
        <table style="width: 300px; background-color: #DFE8F6; border: 1px #99BBE8 solid"
            cellpadding="3" runat="server" id="tblRegisterFields" visible="true">
            <tr>
                <td colspan="3" height="24" align="center">
                    <asp:Label ID="lblRegisterTitle" runat="server" Font-Bold="True" ForeColor="#15428B" Text="Register"></asp:Label>
                </td>
            </tr>
            <tr>
                <td align="right">
                    <asp:Label ID="lblRegisterUserNameCaption" runat="server" Text="User name:"></asp:Label>
                </td>
                <td colspan="2" align="left">
                    <asp:TextBox ID="txtRegisterUserName" runat="server" Width="140px"></asp:TextBox>
                    <asp:RequiredFieldValidator ID="RequiredFieldValidator2" runat="server" ControlToValidate="txtRegisterUserName"
                        ErrorMessage="*"></asp:RequiredFieldValidator>
                </td>
            </tr>
            <tr>
                <td align="right">
                    <asp:Label ID="lblRegisterPasswordCaption" runat="server" Text="Password:"></asp:Label>
                </td>
                <td colspan="2" align="left">
                    <asp:TextBox ID="txtRegisterPassword" runat="server" Width="140px" TextMode="Password"></asp:TextBox>
                    <asp:RequiredFieldValidator ID="RequiredFieldValidator3" runat="server" ControlToValidate="txtRegisterPassword"
                        ErrorMessage="*"></asp:RequiredFieldValidator>
                </td>
            </tr>
            <tr>
                <td align="right">
                    <asp:Label ID="lblRegisterPasswordCaption2" runat="server" Text="Repeat password:"></asp:Label>
                </td>
                <td colspan="2" align="left">
                    <asp:TextBox ID="txtRegisterPassword2" runat="server" Width="140px" TextMode="Password"></asp:TextBox>
                    <asp:RequiredFieldValidator ID="RequiredFieldValidator4" runat="server" ControlToValidate="txtRegisterPassword2"
                        ErrorMessage="*"></asp:RequiredFieldValidator>
                </td>
            </tr>
            <tr>
                <td align="right">
                    <asp:Label ID="lblRegisterEmailCaption" runat="server" Text="Email:"></asp:Label>
                </td>
                <td colspan="2" align="left">
                    <asp:TextBox ID="txtRegisterEmail" runat="server" Width="140px"></asp:TextBox><asp:RequiredFieldValidator  ID="RequiredFieldValidator5" runat="server" ControlToValidate="txtRegisterEmail"
                        ErrorMessage="*"></asp:RequiredFieldValidator>
                </td>
            </tr>
            <tr>
                <td align="right">
                    <asp:Label ID="lblRegisterExtraInfoCaption" runat="server" Text="Extra info:"></asp:Label>
                </td>
                <td colspan="2" align="left">
                    <asp:TextBox ID="txtRegisterExtraInfo" runat="server" Width="140px" TextMode="multiline"></asp:TextBox>
                </td>
            </tr>
            <tr>
                <td align="center" colspan="3">
                    <asp:Label ID="lblRegisterCaptchaCaption" runat="server" Text="Enter the text you see in the below image:"></asp:Label>
                </td>
            </tr>
            <tr>
                <td colspan="3" align="center">
                    <asp:TextBox ID="txtRegisterCaptcha" runat="server" Width="140px"></asp:TextBox>
                </td>
            </tr>
            <tr>
                <td align="center" colspan="3">
                    <asp:Image ID="Image1" ImageUrl="~/Handlers/Captcha.aspx" AlternateText="Image Verification" runat="server"/>
                </td>
            </tr>
            <tr>
                <td align="center" colspan="3">
                <asp:Button ID="btnRegisterSubmit" style="font-family: Tahoma; font-size: 13px;" runat="server" Text="Submit" OnClick="btnRegisterSubmit_Click" />
                </td>
            </tr>
        </table>
        <table style="width: 300px; background-color: #DFE8F6; border: 1px #99BBE8 solid;" 
            cellpadding="3" runat="server" id="tblRegisterStatus" visible="false">
            <tr>
                <td align="center" colspan="3">
                    <asp:Label ID="lblRegisterStatus" runat="server" ForeColor="Red" Text="Error"></asp:Label>
                </td>
            </tr>
        </table>
        </div>
    </form>
    
    <div id="linksBlock" align="center" runat="server">
        <asp:HyperLink ID="lnkLogin" NavigateUrl="~/Default.aspx" runat="server">Login</asp:HyperLink>
        <% if (Utils.UserSettings.EnablePasswordRecovery && !Utils.UserSettings.WindowsUsersWithFormAuth) { %><asp:HyperLink ID="lnkRecoverPassword" NavigateUrl="~/Default.aspx?RecoverPassword=" runat="server">Forgot password?</asp:HyperLink><% } %>
        <% if (Utils.UserSettings.EnableChangeEmail && !Utils.UserSettings.WindowsUsersWithFormAuth) { %><asp:HyperLink ID="lnkChangeEmail" NavigateUrl="~/Default.aspx?ChangeEmail=" runat="server">Change Email</asp:HyperLink><% } %>
        <% if (Utils.UserSettings.EnableAnonymRegister && !Utils.UserSettings.WindowsUsersWithFormAuth) { %><asp:HyperLink ID="lnkRegister" NavigateUrl="~/Default.aspx?Register=" runat="server">Register</asp:HyperLink><% } %>
        <br/><br/>
		<asp:HyperLink ID="lnkMobileVersion" NavigateUrl="~/Default.aspx?Mobile=" runat="server">Mobile version</asp:HyperLink>
    </div>
    <div id="mainBody" runat="server">
        <div id="loading-mask">
        </div>
        <div id="loading">
		<noscript><font color="#CC0000"><%= HttpCommander.Utils.LocalizationsManager.GetString("CommonNoScript")%></font><br/></noscript>
            <table id="loading-message">
                <tr>
                    <td nowrap="nowrap">
                        <img width="32" height="32" alt="" src="Images/loading.gif" />
                    </td>
                    <td nowrap="nowrap">
                        <%= HttpCommander.Utils.LocalizationsManager.GetString("CommonApplicationLoading") %>...
                    </td>
                </tr>
            </table>
            <div style="visibility:hidden;">
<% try { foreach (string imgFile in Directory.GetFiles(System.Web.Hosting.HostingEnvironment.MapPath("~/Images"))) {
string ext = System.IO.Path.GetExtension(imgFile) ?? string.Empty;
ext = ext.TrimStart('.').ToLower();
if (ext == "png" || ext == "gif" || ext == "ico") { %><img width="0" height="0" alt="" src="Images/<%=System.IO.Path.GetFileName(imgFile) %>" />
<% } } } catch { } %>
<% try { foreach (string imgFile in Directory.GetFiles(System.Web.Hosting.HostingEnvironment.MapPath("~/Images/resources_1.5/images/default/tree"), "elbow*.gif"))
   { %><img width="0" height="0" alt="" src="Images/resources_1.5/images/default/tree/<%=System.IO.Path.GetFileName(imgFile) %>" />
<% } } catch { } %><img width="0" height="0" alt="" src="Images/ext/file.png" />
<img width="0" height="0" alt="" src="Images/ext/folder.png" />
<img width="0" height="0" alt="" src="Images/resources_1.5/images/default/menu/menu-parent.gif" />
<img width="0" height="0" alt="" src="Images/resources_1.5/images/default/layout/mini-bottom.gif" />
<img width="0" height="0" alt="" src="Images/resources_1.5/images/default/layout/mini-top.gif" />
            </div>
        </div>
        <script type="text/javascript" src="Scripts/ext-base.js"></script>
        <script type="text/javascript" src="Scripts/ext-all.js"></script>
        <script type="text/javascript" src="Scripts/MultipleFileUploadField.js"></script>
        <script type="text/javascript" src="Handlers/TreeHandler.ashx"></script>
        <script type="text/javascript" src="Handlers/GridHandler.ashx"></script>
        <script type="text/javascript" src="Handlers/CommonHandler.ashx"></script>
        <script type="text/javascript" src="Handlers/Config.ashx"></script>
        <script type="text/javascript" src="Handlers/AdminHandler.ashx"></script>
        <script type="text/javascript" src="Handlers/MetadataHandler.ashx"></script>
        <script type="text/javascript" src="Handlers/GoogleDocsHandler.ashx"></script>
        <script type="text/javascript" src="Handlers/UploadFromURLHandler.ashx"></script>
        <script type="text/javascript" src="Handlers/DropboxHandler.ashx"></script>
        <script type="text/javascript" src="Scripts/ext-columns.js"></script>
        <script type="text/javascript" src="Scripts/ext-filters.js"></script>
        <script type="text/javascript" src="Scripts/Main.js"></script>
        <!-- Example of embedding of the HTTP Commander in a page part. Uncomment the following div (should have 'httpCommander' identifier ) -->
        <!-- <div id="httpCommander" style="width: 800px; height: 500px; margin-left: 100px; margin-top: 100px"></div> -->
    </div>
    <div id="touchBody" runat="server">  
        <div id="middleTouch">
        <div id="loadingTouch">
		<noscript><font color="#CC0000"><%= HttpCommander.Utils.LocalizationsManager.GetString("CommonNoScript")%></font><br/></noscript>
            <table id="loadingTouch-message">
                <tr>
                    <td nowrap="nowrap">
                        <img width="32" height="32" alt="" src="Images/loading.gif" />
                    </td>
                    <td nowrap="nowrap">
                        <%= HttpCommander.Utils.LocalizationsManager.GetString("CommonApplicationLoading") %>...
                    </td>                    
                </tr>
            </table>
        </div>
        </div>     
        <script type="text/javascript" src="Scripts/mobile/sencha/sencha-touch.js"></script>      
        <script type="text/javascript" src="Scripts/mobile/sencha/ext-direct.js"></script>     
        <script type="text/javascript" src="Scripts/mobile/FileUploadField.js"></script>       
        <script type="text/javascript" src="Handlers/GridHandler.ashx"></script>
        <script type="text/javascript" src="Handlers/CommonHandler.ashx"></script>
        <script type="text/javascript" src="Handlers/Config.ashx"></script>        
        <script type="text/javascript" src="Scripts/mobile/main.js"></script>
        
    </div>
    <div id="jqmBody" runat="server">  
       <div id="middleTouch">
        <div id="loadingTouch">
		<noscript><font color="#CC0000"><%= HttpCommander.Utils.LocalizationsManager.GetString("CommonNoScript")%></font><br/></noscript>
            <table id="loadingTouch-message">
                <tr>
                    <td nowrap="nowrap">
                        <img width="32" height="32" alt="" src="Images/loading.gif" />
                    </td>
                    <td nowrap="nowrap">
                        <%= HttpCommander.Utils.LocalizationsManager.GetString("CommonApplicationLoading") %>...
                    </td>
                </tr>
            </table>
        </div>
        </div>
        
        <script type="text/javascript">
            //Simple cap
            Ext = { ns: function(nspace) { } };
            HttpCommander = { Remote: {} };
            var defaultPath="<%=Request.QueryString["path"] %>";
            if(defaultPath == null || defaultPath=="" || defaultPath==undefined)
                defaultPath = "root";
        </script>      
                    
        <script type="text/javascript" src="Handlers/GridHandler.ashx"></script>
        <script type="text/javascript" src="Handlers/CommonHandler.ashx"></script>
        <script type="text/javascript" src="Handlers/Config.ashx"></script>        
        <script type="text/javascript" src="Scripts/mobile/main_jqm.js"></script>
        
        <div data-role="page" id="jqm-main-list">
            <div data-role="header" id="jqm-main-header" data-backbtn="false">
                <a href="#jqm-main-list" data-direction="reverse" data-icon="back" id="jqm-main-header-btnBack" visible=false><%= HttpCommander.Utils.LocalizationsManager.GetString("CommandBack")%></a>
		        <h1 id="jqm-main-header-caption"><%= HttpCommander.Utils.LocalizationsManager.GetString("CommonMainTitle")%></h1>	        
	            <a id="jqm-main-header-btnSettings" href="#jqm-optionsMenu" data-rel="dialog" data-transition="pop" data-icon="gear" class="ui-btn-right" data-theme="a" ><%= HttpCommander.Utils.LocalizationsManager.GetString("CommandSettings")%></a>
	        </div><!-- /header -->

	        <div data-role="content" id="jqm-main-content">	
		        <ul data-role="listview"  id="jqm-main-filesList">
    	            
                </ul>				    
	        </div><!-- /content -->
            
	        <div data-role="footer" id="jqm-main-footer" >		        
		        <!--<a id="jqm-main-footer-btnSettings" href="#jqm-optionsMenu"  data-rel="dialog" data-transition="pop" data-icon="gear" data-theme="a" ><%= HttpCommander.Utils.LocalizationsManager.GetString("CommandSettings")%></a>-->
		        <a id="jqm-main-footer-btnUpload" href="#jqm-upload" data-icon="arrow-u" data-theme="a" style="float:right; margin-right: 1px; "><%= HttpCommander.Utils.LocalizationsManager.GetString("CommandUpload")%></a>
	        </div><!-- /header -->
	    </div>
	    
	    <!-- Settings popup page-->
	    <div data-role="page" id="jqm-optionsMenu">
	        <div data-role="header" id="jqm-optionsMenu-header" data-backbtn="false">
	            <a href="#jqm-main-list" data-direction="reverse" data-icon="back" id="jqm-optionsMenu-header-btnBack"><%= HttpCommander.Utils.LocalizationsManager.GetString("CommandBack")%></a>
	            <h1><%= HttpCommander.Utils.LocalizationsManager.GetString("CommandSettings")%></h1>
	        </div>
            <div data-role="content" id="jqm-optionsMenu-content">	
                <a href="Default.aspx?Mobile=standard" data-role="button"><%= HttpCommander.Utils.LocalizationsManager.GetString("CommandStandardView")%></a>
                <a href="Logout.aspx" data-role="button"><%= HttpCommander.Utils.LocalizationsManager.GetString("CommandLogout")%></a>	       
            </div>
        </div>        
        	    
	    <!-- FileInfo page -->
	    <div data-role="page" id="jqm-fileInfo">
            <div data-role="header" id="jqm-fileInfo-header" data-backbtn="false">
                <a href="#jqm-main-list" data-direction="reverse" data-icon="back" id="jqm-fileInfo-header-btnBack"><%= HttpCommander.Utils.LocalizationsManager.GetString("CommandBack")%></a>
		        <h1 id="jqm-fileInfo-header-caption">&nbsp;</h1>
	        </div><!-- /header -->

	        <div data-role="content" id="jqm-fileInfo-content">	
		       	<div data-role="fieldcontain">
	                <label for="jqm-fileInfo-content-fileName"><%= HttpCommander.Utils.LocalizationsManager.GetString("FileGridNameColumn")%></label>
	                <textarea cols="40" rows="8" name="jqm-fileInfo-content-fileName" id="jqm-fileInfo-content-fileName"></textarea>
                
	                <label for="jqm-fileInfo-content-fileType"><%= HttpCommander.Utils.LocalizationsManager.GetString("FileGridTypeColumn")%></label>	               
	                <input type="text" name="jqm-fileInfo-content-fileType" id="jqm-fileInfo-content-fileType" value=""  />
                
	                <label for="jqm-fileInfo-content-fileSize"><%= HttpCommander.Utils.LocalizationsManager.GetString("FileGridSizeColumn")%></label>	               
	                <input type="text" name="jqm-fileInfo-content-fileSize" id="jqm-fileInfo-content-fileSize" value=""  />
                
	                <label for="jqm-fileInfo-content-fileCreationDate"><%= HttpCommander.Utils.LocalizationsManager.GetString("FileGridCreatedColumn")%></label>	               
	                <input type="text" name="jqm-fileInfo-content-fileCreationDate" id="jqm-fileInfo-content-fileCreationDate" value=""  />
                
	                <label for="jqm-fileInfo-content-fileModificationDate"><%= HttpCommander.Utils.LocalizationsManager.GetString("FileGridModifiedColumn")%></label>	               
	                <input type="text" name="jqm-fileInfo-content-fileModificationDate" id="jqm-fileInfo-content-fileModificationDate" value=""  />                
                    
                    <label for="jqm-fileInfo-content-fileAccessedDate"><%= HttpCommander.Utils.LocalizationsManager.GetString("FileGridAccessedColumn")%></label>	               
	                <input type="text" name="jqm-fileInfo-content-fileAccessedDate" id="jqm-fileInfo-content-fileAccessedDate" value=""  />
	              
                </div>
	        </div><!-- /content -->

	        <div data-role="footer" id="jqm-fileInfo-footer" >
	            <a href="#jqm-main-list" data-icon="arrow-d" data-role="button" id="jqm-fileInfo-footer-btnDownload"><%= HttpCommander.Utils.LocalizationsManager.GetString("CommandDownload")%></a>		        	            
	        </div><!-- /header -->
	    </div>
    </div>
</body>
</html>