﻿<%@ Page Language="C#" %>
<%@ Import Namespace="HttpCommander" %>
<%@ Import Namespace="System.Web.Configuration" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title><%= Utils.LocalizationsManager.GetString("LogoutTitle")%></title>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <meta name="viewport" content="width=device-width; initial-scale=1.0; maximum-scale=1.0; minimum-scale=1.0; user-scalable=0;" />
    <script language="c#" runat="server">
        protected void Page_Load(object sender, EventArgs e)
        {
            string queryString = string.Empty;
            if (this.Session != null && this.Session["DefaultQueryString"] != null)
                queryString = (string)this.Session["DefaultQueryString"];
            hlEnterAgain.NavigateUrl = "~/Default.aspx" + queryString;
            
            /* Do not invoke Session.Clear(), Session.RemoveAll() here.
             We need session variables in the Session_End event handler
             in global.asax. */
            if (Utils.UserSettings.AuthMode == AuthenticationMode.Forms)
            {
                FormsAuthentication.SignOut();
                Session.Abandon();
                lblEndSessionMessage.Text = Utils.LocalizationsManager.GetString("LogoutSessionEnded");
                if (!Utils.UserSettings.IsEmbeddedtoIFRAME)
                    Response.Redirect("Default.aspx" + queryString);
                // unreachable code
            }
            else
            {
                Response.Cache.SetCacheability(HttpCacheability.NoCache);
                if (string.Compare(Request.Browser.Browser, "IE", true) != 0)
                {
                    //For non IE browsers say to user that browser should be closed
                    lblClosingRequired.Text = Utils.LocalizationsManager.GetString("LogoutClosingBrowserRequired");
                    lblEndSessionMessage.Text = "";
                    if (HttpCommander.Utils.UserSettings.Send401AtNonIEWinAuthLogout) Context.Response.StatusCode = 401;
                }
                else
                    lblEndSessionMessage.Text = Utils.LocalizationsManager.GetString("LogoutSessionEnded");
                Response.Expires = -1;
                Response.CacheControl = "No-cache";
                Session.Abandon();
            }
            

            hlEnterAgain.Text = Utils.LocalizationsManager.GetString("LogoutEnterAgain");
            if (Utils.UserSettings.IsEmbeddedtoIFRAME)
                hlCloseWindow.Visible = false;
        }
    </script>
</head>
<!-- The following onload handler clears windows authentication cache for Internet Explorer -->
<body style="font-family: Tahoma; font-size: 13px;background-color:#ffffff;	color:#000000;" onload="javascript:if (navigator.appName == 'Microsoft Internet Explorer') document.execCommand('ClearAuthenticationCache', false);">
    <form id="formLogout" runat="server">
    <div>
        <asp:Label ID="lblEndSessionMessage" runat="server" Text="Current session is ended."></asp:Label>&nbsp;
      <!--  <asp:HyperLink ID="hlCloseWindow"  runat="server" NavigateUrl="javascript:self.close();">Close the window</asp:HyperLink> -->
        &nbsp;
        <asp:HyperLink ID="hlEnterAgain" runat="server">Enter again</asp:HyperLink>
            <br/><br/>
        <asp:Label ForeColor="#990000" ID="lblClosingRequired" runat="server" Text=""></asp:Label>
    </div>
    </form>
</body>
</html>
