
//Main class for all methods and objects
HttpCommander.Main = {
    handleErrors: true,
    configureEventHandlers: function() {
        /*
        Attach event handler to all list item links    
        */
        $('a[id^="listItem"]').live("click", this.listItemClick);
        // button handler for header of file info panel
        $('a[id^="jqm-fileInfo-header-btn"]').bind("click", this.fileInfoHeaderHandler);
        // button handler for footer of file info panel
        $('a[id^="jqm-fileInfo-footer-btn"]').bind("click", this.fileInfoFooterHandler);
        // button handler for header of file list
        $('a[id^="jqm-main-header-btn"]').bind("click", this.fileListHeaderHandler);
        $('a[id^="jqm-main-footer-btn"]').bind("click", this.fileListHeaderHandler);
        // button handler for header in options popup dialog
        $('a[id^="jqm-optionsMenu-header-btn"]').bind("click", this.fileInfoHeaderHandler);

    },
    init: function() {
        try { $("#loadingTouch").remove(); }
        catch (e) { }
        try {
            this.configureEventHandlers();
            //Init object for ext direct communication
            this.extDirect = {
                url: '',
                tid: 1,
                directAction: 'Common',
                directMethod: 'GetInfo',
                responseIsArray: true,
                cbs: new Array(),
                callMethod: function(url, action, method, params, callback) {
                    this.url = url;
                    this.cbs[this.tid] = callback;
                    this.directAction = action;
                    this.directMethod = method;
                    this.params = params;
                    this.load();
                },
                load: function() {
                    var requestData = {
                        type: "rpc",
                        action: this.directAction,
                        method: this.directMethod,
                        tid: this.tid,
                        data: this.params
                    };
                    var that = this;
                    $.mobile.pageLoading();
                    $.ajax({
                        url: this.url,
                        global: false,
                        processData: false,
                        type: "POST",
                        data: $.toJSON(requestData),
                        dataType: "json",
                        async: true,
                        success: function(data, textStatus, jqXHR) {
                            that.complete(data, textStatus, jqXHR, that);
                        }
                    }
                    );
                    this.tid++;
                },
                complete: function(data, textStatus, jqXHR, that) {
                    $.mobile.pageLoading(true);
                    if (that.responseIsArray) data = data[0];
                    if (data.tid && data.type == 'rpc') {
                        that.cbs[data.tid].call(that, data, textStatus, jqXHR);
                        //alert(textStatus+" tid:"+data.tid+" callback: "+that.cbs[data.tid]);
                        //delete that.cbs[data.tid];
                        that.cbs = $.grep(that.cbs, function(val) { return val != that.cbs[data.tid]; });
                    }
                    else if (data.type == 'exception') {
                        if (data.action == 'Grid' && data.method == 'Load')
                            HttpCommander.Main.currentDirectory = HttpCommander.Main.pathUp(HttpCommander.Main.getCurrentFolder());
                        alert(data.message);
                    }
                    return false;
                }
            }

        }
        catch (e) {
            this.ProcessScriptError(e);
        }
        try {
            this.openGridFolder(defaultPath != null ? defaultPath : "root");
        }
        catch (e) {
            this.ProcessScriptError(e);
        }
        //this.extDirect.callMethod(HttpCommander.Remote.GridHandler.url, "Grid","Load", ["name","ASC","root"], this.generateFileList);
    },

    //Render received list data 
    generateFileList: function(data, textStatus, jqXHR, that) {
        if (data.result.success) {
            HttpCommander.Main.currentListData = data.result.data;
            htcConfig.currentPerms = eval("(" + data.result.permissions + ")");
            var fileList = $("#jqm-main-filesList");
            fileList.empty();

            $.each(data.result.data, function(key, value) {
                var itemUrl = "Default.aspx?";
                
                if (window.location.search)
                    itemUrl += window.location.search.substring(1) + "&";
                if (value.rowtype == "folder" || value.rowtype == "rootfolder")
                    itemUrl += "path=" + HttpCommander.Main.pathAppendFolder(HttpCommander.Main.getCurrentFolder(), value.name);
                else if (value.rowtype == "uplink")
                    itemUrl += "path=" + HttpCommander.Main.pathUp(HttpCommander.Main.getCurrentFolder());
                else if (value.rowtype == 'file')
                    itemUrl += "path=" + HttpCommander.Main.getCurrentFolder();
                //Uncomment to add icon (info) for files
                //data-icon="' + (value.rowtype == 'file' ? 'info' : 'false') + '                
                fileList.append('<li class="ui-li-has-icon" data-icon="false">\
                <img class="ui-li-icon" src="' + htcConfig.relativePath + value.icon + '">\
                <a style="white-space:normal" id="listItem' + key + '" href="' + itemUrl + '" >' + value.name + '</a></li>');
            });
            fileList.listview('refresh');
            $.mobile.changePage($("#jqm-main-list"), "none", false, false);
        }
        else {
            HttpCommander.Main.currentDirectory = HttpCommander.Main.pathUp(HttpCommander.Main.getCurrentFolder());
            alert(data.result.msg);
        }
        HttpCommander.Main.folderChanged();
        return false;
    },

    //Render file info panel based on received data
    showFileInfoPanel: function(data, textStatus, jqXHR, that) {
        if (data.result.status == 'success') {
            HttpCommander.Main.fileInfo = data.result;
            //$("#jqm-fileInfo-header-caption").html(curFolder == 'root' ? htcConfig.locData.CommonMainTitle : curFolder);
            $.mobile.changePage($("#jqm-fileInfo"), "none", false, true);
            HttpCommander.Main.configureFileInfoPanel();
        }
        else {
            alert(data.result.msg);
        }
        return false;
    },
    //Get list item object by anchor element
    getListItemIndexByElement: function(item) {
        var id = item.id;
        try { return id.indexOf("listItem") >= 0 ? id.substring(id.indexOf("listItem") + "listItem".length) : -1; }
        catch (e) { }
        return -1;
    },

    //Action on for click event in list
    listItemClick: function() {
        var index = HttpCommander.Main.getListItemIndexByElement(this);
        if (index >= 0) {
            var item = HttpCommander.Main.currentListData[index];
            if (item.rowtype == "folder" || item.rowtype == "rootfolder") {
                var newPath = HttpCommander.Main.pathAppendFolder(HttpCommander.Main.getCurrentFolder(), item.name);
                HttpCommander.Main.openGridFolder(newPath);
            }
            else if (item.rowtype == "uplink") {
                HttpCommander.Main.itemToSelect = HttpCommander.Main.getCurrentFolderName();
                var newPath = HttpCommander.Main.pathUp(HttpCommander.Main.getCurrentFolder());
                HttpCommander.Main.openGridFolder(newPath);
            }
            else if (item.rowtype == "file") {
                HttpCommander.Main.loadFileInfo(item);
            }
        }
        return false;
    },
    //Action for folder change
    folderChanged: function() {
        var curFolder = HttpCommander.Main.getCurrentFolderName();
        $("#jqm-main-header-caption").html(curFolder == 'root' ? htcConfig.locData.CommonMainTitle : curFolder);
        if (curFolder == 'root')
            $("#jqm-main-header-btnBack").hide()
        else
            $("#jqm-main-header-btnBack").show();
        var uploadVisible = !this.isiPhone() && htcConfig.currentPerms && htcConfig.currentPerms.upload;
        if ($("#jqm-main-footer-btnUpload"))
            uploadVisible ? $("#jqm-main-footer-btnUpload").show() : $("#jqm-main-footer-btnUpload").hide();
    },
    //Configure file info panel before display 
    configureFileInfoPanel: function() {
        $("#jqm-fileInfo-content-fileName").text(this.fileInfo.name);
        $("#jqm-fileInfo-content-fileType").val(this.fileInfo.type);
        $("#jqm-fileInfo-content-fileSize").val(HttpCommander.Main.sizeRenderer(this.fileInfo.size));
        $("#jqm-fileInfo-content-fileCreationDate").val(HttpCommander.Main.dateRenderer(this.fileInfo.datecreated));
        $("#jqm-fileInfo-content-fileModificationDate").val(HttpCommander.Main.dateRenderer(this.fileInfo.datemodified));
        $("#jqm-fileInfo-content-fileAccessedDate").val(HttpCommander.Main.dateRenderer(this.fileInfo.dateaccessed));
        var downloadVisible = htcConfig.currentPerms && htcConfig.currentPerms.download;
        if ($("#jqm-fileInfo-footer-btnDownload"))
            downloadVisible ? $("#jqm-fileInfo-footer-btnDownload").show() : $("#jqm-fileInfo-footer-btnDownload").hide();
    },

    //Handlers for header/footer button
    fileInfoHeaderHandler: function() {
        switch (this.id) {
            case "jqm-fileInfo-header-btnBack":
                $.mobile.changePage($("#jqm-main-list"), "none", false, true);
                break
            case "jqm-optionsMenu-header-btnBack":
                $.mobile.changePage($("#jqm-main-list"), "none", true, true);
                break;
        }
        return false;
    },

    fileInfoFooterHandler: function() {
        switch (this.id) {
            case "jqm-fileInfo-footer-btnDownload":
                //$.mobile.changePage($("#jqm-main-list"), "slide", true, true);
                HttpCommander.Main.downloadFile(HttpCommander.Main.fileInfo.name, HttpCommander.Main.getCurrentFolder());
                break;
        }
        return false;
    },

    fileListHeaderHandler: function() {
        switch (this.id) {
            case "jqm-main-header-btnBack":
                HttpCommander.Main.itemToSelect = HttpCommander.Main.getCurrentFolderName();
                var newPath = HttpCommander.Main.pathUp(HttpCommander.Main.getCurrentFolder());
                HttpCommander.Main.openGridFolder(newPath);
                break;
            case "jqm-main-header-btnSettings":
            case "jqm-main-footer-btnSettings":
                $.mobile.changePage($("#jqm-optionsMenu"), "none", false, true);
                break;
            case "jqm-main-footer-btnUpload":
                var uploadUrl = "Handlers/UploadJQuery.aspx?";
                if (window.location.search)
                    uploadUrl += window.location.search.substring(1)+"&";
                uploadUrl += "path=" + HttpCommander.Main.getCurrentFolder();
                $.mobile.changePage(uploadUrl, "slide", false, true);
                break;
        }
        return false;
    },

    //download cy\urrent file
    downloadFile: function(name, path, windowOpen) {
        if (htcConfig.currentPerms && htcConfig.currentPerms.download) {
            var fileUrl = htcConfig.relativePath + "Handlers/Download.ashx?action=download&file=" + encodeURIComponent(path) + "/" + encodeURIComponent(name);
            if (!window.open(fileUrl))
                location.href = fileUrl;
        }
    },
    //open specified path
    openGridFolder: function(getPath) {
        HttpCommander.Main.currentDirectory = getPath;
        HttpCommander.Main.extDirect.callMethod(HttpCommander.Remote.GridHandler.url, "Grid", "Load", ["name", "ASC", getPath], HttpCommander.Main.generateFileList);
    },
    //load info for specified item
    loadFileInfo: function(item) {
        var data = { type: item.rowtype, name: item.name, path: this.getCurrentFolder() };
        HttpCommander.Main.extDirect.callMethod(HttpCommander.Remote.CommonHandler.url, "Common", "GetInfo", [data], HttpCommander.Main.showFileInfoPanel);
    },
    /* concatenate path + name producing new path */
    pathAppendFolder: function(path, name) {
        if (path.toLowerCase() == "root")
            return name;
        if (path.length > 0 && path[path.length - 1] != '/')
            path += '/';
        return path + name;
    },

    /* one level up, truncate the last folder */
    pathUp: function(path) {
        var i = path.lastIndexOf('/');
        if (i < 0)
            return "root";
        else
            return path.substr(0, i);
    },

    /*
    Return name of current folder.
    */
    getCurrentFolderName: function() {
        var path = HttpCommander.Main.getCurrentFolder();
        var i = path.lastIndexOf('/');
        if (i < 0)
            return path;
        else
            return path.substr(i + 1);
    },

    // folder opened in HttpCommander
    getCurrentFolder: function() {
        return HttpCommander.Main.currentDirectory;
    },
    /*
    If some error in JS occured
    */
    ProcessScriptError: function(e) {
        if (HttpCommander.Main.handleErrors) {
            var msg = "Script error occured. ";
            if (e != undefined && e.message != undefined && e.name != undefined)
                msg += "Message:" + e.message + " Name: " + e.name;
            window.alert(msg);
        }
        else
            throw e;
    },
    //render size
    sizeRenderer: function(size) {
        if (size == "") return "";
        else if (size < 1024) {
            return size + " bytes";
        } else if (size < 1048576) {
            return (Math.round(((size * 10) / 1024)) / 10) + " KB";
        } else if (size < 1073741824) {
            return (Math.round(((size * 10) / 1048576)) / 10) + " MB";
        } else {
            return (Math.round(((size * 10) / 1073741824)) / 10) + " GB";
        }
    },
    //RenderDate
    dateRenderer: function(date) {
        return new Date(date*1000).toLocaleString();
    },
    //detect apple device . Upload is not supported on apple devices
    isiPhone: function() {
        return (
            (navigator.platform.indexOf("iPhone") != -1) ||
            (navigator.platform.indexOf("iPad") != -1) ||
            (navigator.platform.indexOf("iPod") != -1)
        );
    }
}

//Init main object when document is ready
$(document).ready(function() {
    HttpCommander.Main.init();
});

/*
Parse current query string
*/
$.urlParam = function(name) {
    var results = new RegExp('[\\?&]' + name + '=([^&#]*)').exec(window.location.href);
    if (!results) { return 0; }
    return decodeURIComponent(results[1].replace(/\+/g, " ")) || 0;
}

/*
Make all header and footer fixed if browse compatible
*/
$('div').live('pagebeforecreate.onetime', function() {
    var footer = $('div[data-role="footer"], div[data-role="header"]');
    footer.addClass('ui-footer-fixed');
    footer.addClass('ui-fixed-overlay');
    footer.addClass('fade');
    footer.attr("data-position", "fixed");
    //unbind live event
    $('div').die('pagebeforecreate.onetime');
});