
Ext.data.DirectReader = Ext.extend(Ext.data.JsonReader, {
    resultSet: 'result',
    root: 'data',
    totalCount: 'total',
    readRecords: function(data) {
        data = data[0][this.resultSet];
        return Ext.data.DirectReader.superclass.readRecords.call(this, data);
    }
});

Ext.data.ReaderMgr.registerType('direct', Ext.data.DirectReader);

Ext.data.DirectStore = Ext.extend(Ext.data.Store, {
    transId: 0,
    groupField: 'name',
    constructor: function(config) {
        config = config || {};
        Ext.applyIf(config, {
            proxy: {
                type: 'direct',
                reader: 'direct',
                writer: 'json'
            }
        });
        Ext.data.DirectStore.superclass.constructor.call(this, config);

    },
    getGroupString: function(record) {
        // Group by the name
        return record.get('name').toUpperCase()[0];
    },
    load: function(options) {
        //{"action":"Grid","method":"Load","data":["name","ASC","Demo folder 1"],"type":"rpc","tid":5}
        options = options || {};
        this.transId++;
        Ext.applyIf(options, {
            group: {
                field: this.groupField,
                direction: this.groupDir
            },
            url: this.url,
            limit: this.pageSize,
            addRecords: false,
            params: this.params,
            paramOrder: this.paramOrder,
            directFn: this.directFn,
            jsonData: {
                type: 'rpc',
                action: this.directAction,
                method: this.directMethod,
                tid: this.transId,
                data: []
            }
        });
        return Ext.data.Store.superclass.load.call(this, options);
    }
});
Ext.reg('directstore', Ext.data.DirectStore);

Ext.data.DirectProxy = Ext.extend(Ext.data.AjaxProxy, {
    actionMethods: {
        create: 'POST',
        read: 'POST',
        update: 'POST',
        destroy: 'POST'
    },
    constructor: function() {
        Ext.data.DirectProxy.superclass.constructor.apply(this, arguments);
    },
    doRequest: function(operation, callback, scope) {
        this.url = operation.url;
        var writer = this.getWriter(),
            request = this.buildRequest(operation, callback, scope);

        //if (operation.allowWrite()) {
        request = writer.write(request);
        //}

        Ext.apply(request, {
            headers: this.headers,
            timeout: this.timeout,
            scope: this,
            callback: this.createRequestCallback(request, operation, callback, scope),
            method: this.getMethod(request),
            disableCaching: false
        });

        request.jsonData = operation.jsonData;
        if (operation.paramOrder) {
            request.jsonData.data = [];
            for (var i = 0; i < operation.paramOrder.length; i++) {
                k = operation.paramOrder[i]
                request.jsonData.data[i] = operation.params[k];
            }
        }
        //Direct function support
        /*if (operation.directFn.directCfg.method.len > 0) {
        if (this.paramOrder) {
        for (var i = 0, len = this.paramOrder.length; i < len; i++) {
        request.jsonData.data.push(params[this.paramOrder[i]]);
        }
        } else if (this.paramsAsHash) {
        request.jsonData.data.push(params);
        }
        }*/

        Ext.Ajax.request(request);

        return request;
    },
    listeners: {
    exception: function(proxy, res, arg) {           
            Ext.Msg.show({
                title: htcConfig.locData.CommonErrorCaption,
                msg: "Status: " + res.status + " " + res.statusText + "<br>Message: " + res.message,
                icon: Ext.MessageBox.ERROR,               
                buttons: Ext.Msg.OK
            });
        }
    }
});

Ext.data.ProxyMgr.registerType('direct', Ext.data.DirectProxy);